G - Pascal's Travels HDU - 1208

An n x n game board is populated with integers, one nonnegative integer per square. The goal is to travel along any legitimate path from the upper left corner to the lower right corner of the board. The integer in any one square dictates how large a step away from that location must be. If the step size would advance travel off the game board, then a step in that particular direction is forbidden. All steps must be either to the right or toward the bottom. Note that a 0 is a dead end which prevents any further progress. 


Consider the 4 x 4 board shown in Figure 1, where the solid circle identifies the start position and the dashed circle identifies the target. Figure 2 shows the three paths from the start to the target, with the irrelevant numbers in each removed. 

Figure 1

Figure 2

Input

The input contains data for one to thirty boards, followed by a final line containing only the integer -1. The data for a board starts with a line containing a single positive integer n, 4 <= n <= 34, which is the number of rows in this board. This is followed by n rows of data. Each row contains n single digits, 0-9, with no spaces between them. 

Output

The output consists of one line for each board, containing a single integer, which is the number of paths from the upper left corner to the lower right corner. There will be fewer than 2^63 paths for any board. 

Sample Input

4
2331
1213
1231
3110
4
3332
1213
1232
2120
5
11101
01111
11111
11101
11101
-1

Sample Output

3
0
7


        
  
Brute force methods examining every path will likely exceed the allotted time limit. 
64-bit integer values are available as "__int64" values using the Visual C/C++ or "long long" values 
using GNU C/C++ or "int64" values using Free Pascal compilers. 

Hint

Hint
        

题目大意:从左上角走到右下角问有多少条路径可以走,走到某个点之后你只能向右或者向左走这个点所代表的数值。

解题思路: 记忆化搜索;用dp数组存起来在这个点有多少条路径可以走,在走下一个点时在此基础上在加上多出的路径数即可。

注意:路径数值比较大,用C++提交dp要定义成 _int 64 dp[] 用G++提交定义成long long dp[];

代码:

#include<stdio.h>
int a[120][120];

int main()
{  int n;
    while(~scanf("%d",&n))
    {
        if(n==-1)
            break;
        _int64 dp[120][120]={0};
        int i,j;
        char s[500][500];
        for(i=0; i<n; i++)
            scanf("%s",s[i]);
        for(i=0; i<n; i++)
            for(j=0; j<n; j++)
                a[i][j]=s[i][j]-'0';
        dp[0][0]=1;
        for(i=0; i<n; i++)
            for(j=0; j<n; j++)
            {
                if(a[i][j]==0)
                    continue;
                dp[i][j+a[i][j]]+=dp[i][j];
                dp[i+a[i][j]][j]+=dp[i][j];
            }
        printf("%I64d\n",dp[n-1][n-1]);
    }
    return 0;
}

猜你喜欢

转载自blog.csdn.net/TANG3223/article/details/81274862